<?php
/**
 * A file i/o iterator
 *
 * @author		Roland Haeder <webmaster@ship-simu.org>
 * @version		0.0.0
 * @copyright	Copyright (c) 2007, 2008 Roland Haeder, 2009 - 2012 Hub Developer Team
 * @license		GNU GPL 3.0 or any newer version
 * @link		http://www.ship-simu.org
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
class FileIoIterator extends BaseIterator implements SeekableWritableFileIterator {
	/**
	 * Current absolute seek position (returned by key())
	 */
	private $seekPosition = FALSE;

	/**
	 * Total entries (read from file)
	 */
	private $totalEntriesFile = FALSE;

	/**
	 * Protected constructor
	 *
	 * @return	void
	 */
	protected function __construct () {
		// Call parent constructor
		parent::__construct(__CLASS__);
	}

	/**
	 * Creates an instance of this class
	 *
	 * @param	$pointerInstance	An instance of a InputOutputPointer class
	 * @return	$iteratorInstance	An instance of a Iterator class
	 */
	public final static function createFileIoIterator (InputOutputPointer $pointerInstance) {
		// Get new instance
		$iteratorInstance = new FileIoIterator();

		// Set the instance here
		$iteratorInstance->setPointerInstance($pointerInstance);

		// Return the prepared instance
		return $iteratorInstance;
	}

	/**
	 * Gets currently read data
	 *
	 * @return	$current	Currently read data
	 */
	public function current () {
		// Default is null
		$current = null;

		$this->partialStub('Please implement this method.');

		// Return it
		return $current;
	}

	/**
	 * Gets current seek position ("key").
	 *
	 * @return	$key	Current key in iteration
	 */
	public function key () {
		// Default is null
		$key = null;

		$this->partialStub('Please implement this method.');

		// Return it
		return $key;
	}

	/**
	 * Advances to next "block" of bytes
	 *
	 * @return	void
	 */
	public function next () {
		$this->partialStub('Please implement this method.');
	}

	/**
	 * Rewinds to the beginning of the file
	 *
	 * @return	void
	 */
	public function rewind () {
		$this->partialStub('Please implement this method.');
	}

	/**
	 * Seeks to given position
	 *
	 * @param	$seekPosition	Seek position in file
	 * @return	void
	 */
	public function seek ($seedPosition) {
		$this->partialStub('Please implement this method. seekPosition=' . $seekPosition);
	}

	/**
	 * Size of file stack
	 *
	 * @return	$size	Size (in bytes) of file
	 */
	public function size () {
		// Call the pointer object
		$size = $this->getPointerInstance()->size();

		// Return result
		return $size;
	}

	/**
	 * Checks wether the current entry is valid (not at the end of the file).
	 * This method will return TRUE if an emptied (nulled) entry has been found.
	 *
	 * @return	void
	 */
	public function valid () {
		$this->partialStub('Please implement this method.');
	}
}

// [EOF]
?>
